-------------------
-- NUEVOS
-------------------

PORT SolInv SINGLE "Salida del panel solar al inversor solar"

	REAL Vmax		"Tensin de los paneles solares (V)"
	REAL Imax		"Corriente de los paneles solares (A)"
	REAL Pact    	"Potencia mxima generada por los paneles Solares (W)"
	REAL Iscg		"Corriente de corto circuito (A)"
	
END PORT


PORT InvAlt SINGLE OUT "Salida de corriente alterna del inversor solar y de viento"

	EQUAL REAL Vmax
	SUM IN REAL Imax
	SUM IN REAL Pact

END PORT


PORT caudalpuerto SINGLE	

	EQUAL REAL qin
	
END PORT


PORT ContBomb SINGLE
	
	REAL nbomba

END PORT

PORT AlturaTanque SINGLE

	REAL HT

END PORT

PORT CaudalBomba	SINGLE

	EQUAL REAL q

END PORT

PORT CaudalRiego SINGLE

	 EQUAL REAL q

END PORT




--------------------------------------------------------------------------------
-- 		SUBSISTEMA SOLAR
--------------------------------------------------------------------------------
	
	PORT MPPTOpt SINGLE "MPPT TRacking - Optimizador"
		
		REAL Vmax						"Voltaje de potencia mxima (Volt)"
		REAL Iscg						"Corriente a corto circuito del arreglo solar (Amp)"
		REAL Pmax						"Potencia mxima (W)"
		
	END PORT
	
	PORT SolarSource "Sensores - Solar"
		
		EQUAL REAL G						   " Radiacin Solar (w/m2)"
		EQUAL REAL Tenv   			 		" Temperatura ambiente (C)"
		
	END PORT
	
	
	PORT BoostPSolar SINGLE "Boost converter - Arreglo Solar"
		
		REAL Vop						   "Voltaje de referencia (Volt)"
		
	END PORT
	

-- PANEL SOLAR - BOOST CIRCUIT  
/*
   PORT PVCV SINGLE " PANEL SOLAR - BOOST CIRCUIT"
		
		REAL Vdc	 		"Voltaje DC a la salida de los paneles solares (Volts)"
				
	END PORT

   PORT PVCI SINGLE " PANEL SOLAR - BOOST CIRCUIT"
		
		REAL Idc			"Corriente DC a la salida de los paneles solares (Amps)"
		
	END PORT

--------------------------------------------------------------------------------
-- PV SOLAR - Voltage Controller 

   PORT PVBCV SINGLE " PV SOLAR - Voltage Controller"
		
		REAL Vdc	 		"Voltaje DC a la salida de los paneles solares (Volts)"
				
	END PORT
			
------------------------------------------------------------------------------		
-- PWM - BOOST Circuit 

   PORT CPWMS SINGLE "PWM - BOOST Circuit"
		
		REAL s	 		"Modulacion del Boost Circuit"
				
	END PORT
	

-------------------------------------------------------------------------------
-- Voltage Controller - PWM  

	PORT PIPWMS SINGLE "Voltage Controller - PWM"
		
		REAL senal	 		"seal de referencia del PWM"
				
	END PORT

-------------------------------------------------------------------------------
-- Reference Voltage Defined - PV Solar  

	PORT RVDPVS SINGLE "Reference Voltage Defined - PV Solar"
		
		REAL Vdc	 		"Voltaje a la salida del panel solar"
		REAL Idc	 		"Corriente a la salida del panel solar"
				
	END PORT

-------------------------------------------------------------------------------
-- Reference Voltage Defined - Voltage Controller  

	PORT RVDVC SINGLE "Reference Voltage Defined - Voltage Controller  "
		
		REAL Uref	 		"Voltaje de Referencia para el Voltage Controller"
				
	END PORT
		
-------------------------------------------------------------------------------
--  FSPC  - Reference Voltage Defined 

	PORT FSPCRVD SINGLE "FSPC  - Reference Voltage Defined"
		
		REAL Plimit	 		"Limit output power (W)"
						
	END PORT

	
--------------------------------------------------------------------------------
--                  PRUEBAS CON SOLAR
--------------------------------------------------------------------------------

-- Panel SOLAR - MPPT  

   PORT PVMPPTV SINGLE " Panel SOLAR - MPPT"
		
		REAL Vdc	 		"Voltaje DC a la salida de los paneles solares (Volts)"
				
	END PORT

   PORT PVMPPTI SINGLE " Panel SOLAR - MPPT"
		
		REAL Idc			"Corriente DC a la salida de los paneles solares (Amps)"
		
	END PORT

------------------------------------------------------------------------------	
-- MPPT - Voltage Controller 

	PORT MPPPIV SINGLE " MPPT - Voltage Controller"
		
		REAL Vref	 		"Reference Voltage"
				
	END PORT
			
------------------------------------------------------------------------------		
-- BOOST Circuit - SB  
		
	PORT CSBV SINGLE " BOOST Circuit - SB"
		
		REAL Vdc	 		"Voltaje DC impuesto por el SB (Volts)"
				
	END PORT

   PORT CSBI SINGLE "BOOST Circuit - SB"
		
		REAL Idc			"Corriente DC producida por el Boost circuit (Amps)"
		
	END PORT		
	*/
	
--------------------------------------------------------------------------------
-- II)WIND SUBSYSTEM: 

-- a) Toma de data
-- b) Wind Turbine 
-- c) Wind Generator

--------------------------------------------------------------------------------

/*	PORT WindrectV SINGLE "Turbina de Viento - Rectificador"

		REAL Vma			"Amplitud del Voltaje del Generador"
			
		CONTINUOUS 

		--Vrmsa=Vma/sqrt(2)

	END PORT
	
	PORT WindrectI SINGLE "Turbina de Viento - Rectificador"
		
	--	REAL Irmsa			"Corriente RMS del generador"
		REAL Ima			"Corriente RMS del generador"
		
		CONTINUOUS 

	--	Irmsa=Ima/sqrt(2)
	
	END PORT
	

	PORT rectWBV SINGLE "Rectificador - Windy Boy"
		
		REAL Vdc	 		"Voltaje DC a la salida del rectificador"
				
	END PORT
	
	PORT rectWBI SINGLE "Rectificador - Windy Boy"
		
		REAL Idc			"Corriente DC a la salida del rectificador"
		
	END PORT
	*/
	
--------------------------------------------------------------------
-- 			TURBINA EOLICA
-------------------------------------------------------------------

	PORT WindVeSource  "Velocidad de Viento"
	
		EQUAL REAL Ve				"Velocidad del Viento (m/seg)"	
						
	END PORT
	
	PORT WTCPuertos	SINGLE "Entrada a la turbina de viento desde el controlador"
	
		REAL Teref 			"Torque de referencia (N.m)"		
		REAL Betaref    	"Angulo de Calaje de referencia (C)"	
						
	END PORT
	
	PORT WTPuertos	 SINGLE "Salida de la turbina de viento"
	
		REAL wt 			   "Velocidad angular de la turbina de viento (rad/seg)"	
		REAL Pmech			"Potencia mecanica generada por la turbina"
						
	END PORT
	
	PORT PotPuertos	 SINGLE "Salida de la turbina de viento"
	
		REAL Pmech			"Potencia mecanica generada por la turbina"
						
	END PORT
	
--------------------------------------------------------------------
-- 			Carga
-------------------------------------------------------------------		
	
	PORT RedPuertos	 SINGLE "Salida de la carga"
	
		REAL Pgrid			"Potencia generada por la carga"
		REAL Qgrid
		
		REAL I
		REAL cosfi
		REAL V
						
	END PORT
	
--------------------------------------------------------------------
-- 			Planta Desalinizadora
--------------------------------------------------------------------	

	PORT Pcargagrid	 SINGLE OUT "Bomba de alimentacion - Red Electrica"
	
		SUM IN REAL Pact			"Potencia activa que consume la bomba de alimentacin (W)"
		SUM IN REAL Qreact			"Potencia reactiva que consume la bomba de alimentacin (var)"
		
		SUM IN REAL cosfi
		SUM IN REAL I
		EQUAL REAL V
								
	END PORT


	PORT DPB01	 SINGLE "Bomba de desplazamiento - Bomba de alta presion"
	
		REAL DP01			"Diferencia de presion de la bomba B01"
		REAL Pinit        "Presion en la boquilla del tanque T1 (bar)"
		REAL q				"Flujo desde la bomba de desplamizamiento a la bomba de alta presion (m3/seg)"
		REAL P				"Potencia activa consumida por la bomba B01 (W)"
		REAL Q				"Potencia reactiva consumida por la bomba B01 (W)"
								
	END PORT
	
	PORT CLB02	 SINGLE "Bomba de desplazamiento - Bomba de alta presion"
	
		REAL DP02			"Diferencia de presion de la bomba B01"
		REAL Pinit        "Presion en la boquilla del tanque T1 (bar)"
		REAL q				"Flujo desde la bomba de limpieza a la bomba de alta presion (m3/seg)"
		REAL P				"Potencia activa consumida por la bomba B02 (W)"
		REAL Q				"Potencia reactiva consumida por la bomba B02 (W)"
								
	END PORT
	
	PORT Tanq1B01	 SINGLE "Bomba de desplazamiento - Tanque1"
	
		REAL HT1			"Altura del tanque 1 (m)"
								
	END PORT
	
	PORT B01Tanq1	 SINGLE "Tanque1-Bomba de desplazamiento"
	
		REAL q			"Flujo de la bomba de desplazamiento (m3/seg)"
								
	END PORT
	
	PORT B04Tanq1	 SINGLE "Tanque1-Bomba de alimentacion"
	
		REAL q			"Flujo de la bomba de desplazamiento (m3/seg)"
								
	END PORT
	
	PORT Tanq1CH	 SINGLE "Tanque1-control de histeresis"
	
		REAL HT1			"Altura del tanque 1 (m)"
								
	END PORT
	
	PORT CHFeedB	 SINGLE "control de histeresis - Bomba de alimentacin"
	
		REAL nfeed			"Activacin de la bomba de alimentacion"
								
	END PORT
	
	PORT B02Tanqcl	 SINGLE "Bomba de limpiezas - Tanque de limpieza"
	
		REAL q				"Flujo de la bomba de limpieza (m3/seg)"
								
	END PORT
	
	
	PORT B03Mem	 SINGLE "Bomba B03 - Membrana de Osmosis Inversa"
	
		REAL q				"Flujo de la bomba B03 a la membrana de osmosis inversa (m3/seg)"	
		REAL P				"Presion en la boquila de la membrana de osmosis inversa (bar)"
								
	END PORT
	
	PORT MemVal	 SINGLE "Membrana de Osmosis Inversa - Valvula"
	
		REAL q				"Flujo de la membrana de osmosis inversa (m3/seg)"		
								
	END PORT
	
	PORT ValTCL	 SINGLE "Valvula - Tanque de limpieza"
	
		REAL q				"Flujo dirigido al tanque de limpieza (m3/seg)"		
								
	END PORT
	
	PORT ValT2	 SINGLE "Valvula - Tanque 2 de salida"
	
		REAL q				"Flujo dirigido al tanque 2 de salida (m3/seg)"		
								
	END PORT
	
	PORT SourceT2	 SINGLE "Consumo - Tanque 2"
	
		REAL q				"Flujo dirigido al consumo del pueblo (m3/seg)"		
								
	END PORT
	
	PORT Tanq2CH	 SINGLE "Consumo - Tanque 2"
	
		REAL HT2				"Altura del tanque 2 (m)"		
								
	END PORT
	
	
	PORT CHB01 SINGLE "Control de histeresis - Bomba de desplazamiento"
	
		REAL ndes				"Activacin de la rama de desalinizacin"		
								
	END PORT

--------------------------------------------------------------------
-- 	RED ELECTRICA
--------------------------------------------------------------------		
 					
 	PORT PgridFuente SINGLE OUT "Paneles Solares al Sunny Island"
	
		SUM IN REAL Pact    "Potencia generada por los paneles Solares (W)"
						
	END PORT
 					

--------------------------------------------------------------------------------
-- IV) SUNNY ISLAND
--------------------------------------------------------------------------------


	PORT SBSIV "Conexion del Inversor Solar (SB) al inversor de baterias (SI)"
		
	--	REAL Vrmsb				"Voltaje RMS del Inversor (Volts)"
		EQUAL REAL Vmb			"Amplitud de Voltaje del Inversor (Volts)"
		EQUAL REAL fac			"Frecuencia de la red (Hz)"
		
		REAL cosfi
		REAL I
		
		CONTINUOUS 
		
	--	Vrmsb=Vmb/sqrt(2)
		
	END PORT
	
	PORT WBSIV "Conexion del inversor de turbina (WB) al inversor de baterias (SI)"
		
	--	REAL Vrmsb		"Voltaje RMS del Inversor (Volts)"
		EQUAL REAL Vmb			"Amplitud de Voltaje del Inversor (V)"
		EQUAL REAL fac			"Frecuencia de la red (Hz)"
		
		CONTINUOUS 
		
	--	Vrmsb=Vmb/sqrt(2)
		
	END PORT

--------------------------------------------------------------------------------
-- NO sirve
--------------------------------------------------------------------------------

/*	PORT SBSII SINGLE "Conexion de los sunny boys y el windy boy a los sunny island"
		
		--REAL Irmsb		"Corriente RMS del Inversor (Amps)"
		REAL Imb			   "Amplitud de corriente del Inversor (Amps)"
				
		CONTINUOUS 
		
		--Irmsb=Imb/sqrt(2)
		
		
	END PORT
	
*/
	
------------------------------------------------------------------------------
--                Nuevo Experimento
------------------------------------------------------------------------------

	PORT CCBatV SINGLE "Conexion Bateria - Cuk converter"
		
		REAL Vbat
		
	END PORT
	
	PORT CCBatI SINGLE "Conexion Bateria - Cuk converter"
		
		REAL Ibat
		
	END PORT
	   	
	       		

--------------------------------------------------------------------------------
--						 GENERADOR DIESEL
--------------------------------------------------------------------------------

	
	PORT DieEngGen SINGLE "Maquina Diesel - Generador"
		
		REAL Tsg			"Par del generador (pu)"
		
	END PORT

	PORT ExciGen SINGLE "Fuente de excitacion - Generador"
		
		REAL Efd			"Voltaje de excitacion (pu)"
		
	END PORT

	PORT GenExc SINGLE " Generador - Fuente de excitacion"
		
		REAL Vt			"Voltaje Terminal del estator(pu)"
		
	END PORT
