/*-----------------------------------------------------------------------------------------
 LIBRARY: RENEWABLE
 FILE: TanqueRiego
 CREATION DATE: 08/03/2016
-----------------------------------------------------------------------------------------*/
USE MATH

COMPONENT TanqueRiego
	"Tanque de almacenamiento de agua para riego"

PORTS  

----------------------------------------------------------------------
-- Entradas: 
-- Flujo proveniente de la bomba
-- Flujo proveniente del consumo de agua
----------------------------------------------------------------------

	IN CaudalBomba						CaudalBombab
	IN CaudalRiego						CaudalRiegoa
	
	
----------------------------------------------------------------------
-- Salidas: 
-- Altura del Tanque 
----------------------------------------------------------------------

	OUT AlturaTanque						AlturaTanquea


DATA 

	REAL AreaT=2							" Area del tanque 1 (m2)"
	REAL HmaxT=2.95						" Atura del tanque mxima (m)"
	REAL HminT=0.05						" Atura del tanque mnima (m)"
	
		
DECLS

	REAL HT									" Altura del tanque (m)"
	REAL qin									"Flujo de entrada de la bomba de alimentacion B04 (m3/seg)"
	REAL qout								"Flujo de salida de la bomba B01 (m3/seg)"
	
	

INIT

	HT=1
    	     
CONTINUOUS

	qin=CaudalBombab.q

	qout= ZONE ((HT<=HminT) AND (CaudalRiegoa.q>qin)) qin
			ZONE ((HT<=HminT) AND (qin<=0)) 0
	      OTHERS CaudalRiegoa.q
	
	HT'=(qin-qout)/AreaT
	
	AlturaTanquea.HT=HT
		
END COMPONENT