USE MATH

COMPONENT analisisCP
	"Modela la ecuacin definida para el coeficiente de potencia Cp. Resultados no incluidos en las simulaciones."
-- El objetivo del presente modulo es modelar la ecuacion definida para el CP
-- son de simple consulta para el programador
-- y sus resultados no sern incluidos en el resto de la simulacion

-- Fecha de Actualizacion: 09/07/2010

DATA 

	REAL B[9]= { 0, 5, 10, 15, 20, 25, 30, 35, 40}					" Blade pitch angle (C)"
 	
	REAL R=4.5						"Radio de la turbina (m)"
	REAL Cf=15						"Constante del modelo de Cp"
	REAL ka=0.5					" Constante auxiliar"
	REAL kb=114						" Constante auxiliar"
	REAL kc=0.4						" Constante auxiliar"
	REAL kd=3						" Constante auxiliar"
	REAL ke=25					" Constante auxiliar"
	REAL kf=0.000571				" Constante auxiliar"
	
DECLS
 		
	REAL Cp[9]						" Power Coefficient"
	REAL Cpa[9]						" Power Coefficient"
	REAL Cpb[9]						" Power Coefficient"
	REAL Cpc[9]						" Power Coefficient"
	REAL Cpd[9]						" Power Coefficient"
	REAL Cpe[9]						" Power Coefficient"
	REAL Cpf[9]						" Power Coefficient"
	REAL Cpg[9]						" Power Coefficient"
	REAL lamda						" Tip Speed Radio"
	REAL lamdai[9]					" Tip Speed Radio"
	REAL lamdae[9]					" Tip Speed Radio"
	REAL aux[9]
		
	
		
INIT
    	     
CONTINUOUS

 EXPAND_BLOCK   (i IN 1, 9)
 
 -- Primer modelo del coeficiente de Potencia
 
 Cpa[i]=((0.44-(0.0167*B[i]))*sin((PI*(lamda-3))/(15-(0.3*B[i]))))-(0.00184*(lamda-3)*B[i])
 
 
 Cp[i]= ZONE (Cpa[i]<=0) 0
		  OTHERS Cpa[i]
		  
  -- Segundo modelo del coeficiente de Potencia
  

  Cpb[i]= ZONE (lamda<=1) 0
		    OTHERS(1/2)*((((R*Cf)/lamda)-(0.322*B[i])-2)*exp(-(0.255*R*Cf)/lamda)) 
  
  Cpc[i]= ZONE (Cpb[i]<=0) 0
		    OTHERS Cpb[i]	
		    
	-- Tercer modelo del coeficiente de Potencia
  
  lamdai[i]=1/((1/(lamda+(0.08*B[i])))-(0.035/((B[i]**3)+1)))
  
  Cpd[i]=(ka*((kb/lamdai[i])-(kc*B[i])-(kd))*exp(-ke/lamdai[i]))+(kf*lamda)
  
  Cpe[i]= ZONE (Cpd[i]<=0) 0
		    OTHERS Cpd[i]
  
  	-- Cuarto modelo del coeficiente de Potencia
  	
  	aux[i]= ZONE ((lamda-(0.02*B[i]))<=0) 0.1
  			  OTHERS (lamda-(0.02*B[i]))
  	
  	lamdae[i]=1/((1/aux[i])-(0.003/((B[i]**3)-1)))
  
    
   Cpf[i]=(1.435*((174/lamdae[i])-(0.4*B[i])-(0.004*(B[i]**2.14))-12)*exp(-28.75/lamdae[i]))
	
	Cpg[i]= ZONE (Cpf[i]<=0) 0
		    OTHERS Cpf[i]  
		    
		     
    
END EXPAND_BLOCK
	
END COMPONENT
